Subject: Re: best git practices, was Re: Git User's Survey 2007 unfinished summary continued

From: Andreas Ericsson <[email-masked]>
Date: Tue, 23 Oct 2007 09:24:40 +0200

Jakub Narebski wrote:
> On 10/22/07, Andreas Ericsson <[email-masked]> wrote:
>> Johannes Schindelin wrote:
>>> On Mon, 22 Oct 2007, Andreas Ericsson wrote:
>>>
>>>> If I were to suggest any improvements, it'd be to change the semantics of
>>>> git-pull to always update the local branches set up to be merged with the
>>>> remote tracking branches when they, prior to fetching, pointed to the same
>>>> commit, such that when
>>>>
>>>> $ git show-ref master
>>>> d4027a816dd0b416dc8c7b37e2c260e6905f11b6 refs/heads/master
>>>> d4027a816dd0b416dc8c7b37e2c260e6905f11b6 refs/remotes/origin/master
>>>>
>>>> refs/heads/master gets set to refs/remotes/origin/master post-fetch.
>>> In general, this should fail.  Because you are expected to have local
>>> changes in the local branches.
>>
>> BS argument. Git knows when I haven't got any changes on my local
>> branches, and it can be fairly safely assumed that when I feel like
>> making any, I'd like to make them off as fresh a tip as possible unless
>> I explicitly tell git otherwise.
> [cut]
> 
> It would be I think possible to make git behave as you want, although I'd rather
> (at least at first) have behaviour described above turned on by some option
> or config variable. I guess that it would be not that hard to make script to do
> what you ant (and probably it would be best if you tried your idea that way).
> 
> There are the following caveats.
> 1. For each local branch that is to be updated on pull, this branch
> must be marked as tracking some branch of some repository. This has to
> be explicitely done; for example by creating those branches using
> --track option.
> 2. Git can do a merge with conflicts _only_ if that branch is checked
> out. So for all local branches which you want to get updated using
> "git pull --update-all <repo>" (or something like that), the merge
> with remote branch should be either fast-forward, trivial merge, or
> merge without conflicts. "git pull --update-all <repo>" would return
> then list of updated branches and list of branches which cannot be
> updated.
> 
> So... are you going to try to implement that?

Yes, but only for fast-forward cases. When there *are* local changes, 
the user must decide when to merge those, since he/she may not be done 
with them. It doesn't make sense to merge local canges on a not checked 
out branch automagically, because then we end up in the very unclear 
semantics that Dscho (and myself) fear.

Also, as Steffen pointed out in his mail, this will make "git pull" 
largely symmetrical with "git push", which *does* update all the remote 
branches, but only if the update results in a fast-forward.

-- 
Andreas Ericsson                   [email-masked]
OP5 AB                             www.op5.se
Tel: +46 8-230225                  Fax: +46 8-230231